<?php
require_once('dbconnect.php');
require_once('user_rank.php');

# generate a bdd cache for topic $id
function forum_cache_topic($id, $bdd, $new=false) {
	$req = $bdd->prepare('SELECT * FROM `forum_topics` WHERE `id`=? LIMIT 1');
	$req->execute(array($id));
	if($data = $req->fetch()) {
		$authorhtml = '';
		$req = $bdd->prepare('SELECT `username`,`settings` FROM `accounts` WHERE `id`=? LIMIT 1');
		$req->execute(array($data['author']));
		if($data2 = $req->fetch())
			$authorhtml = urank(json_decode($data2['settings'],true)['rank'], $data2['username']);
		else
			$authorhtml = urank('a');
		$req = $bdd->prepare('SELECT `id`,`author`,`date` FROM `forum_posts` WHERE `master`=? ORDER BY `date` DESC');
		$req->execute(array($id));
		$n = 0;
		$lastauthor = 0;
		$lastdate = 0;
		$lastpost = 0;
		while($data2 = $req->fetch()) {
			if($n == 0) {
				$lastauthor = $data2['author'];
				$lastdate = $data2['date'];
				$lastpost = $data2['id'];
			}
			$n ++;
		}
		$lastauthorhtml = '';
		if($lastauthor != 0 and $lastdate != 0) {
			$req = $bdd->prepare('SELECT `username`,`settings` FROM `accounts` WHERE `id`=? LIMIT 1');
			$req->execute(array($lastauthor));
			if($data2 = $req->fetch())
				$lastauthorhtml = urank(json_decode($data2['settings'],true)['rank'], $data2['username']);
			else
				$lastauthorhtml = urank('a');
		}
		$req = $bdd->prepare('SELECT `id` FROM `forum_cache_topics` WHERE `topic_id`=? LIMIT 1');
		$req->execute(array($id));
		if($data2 = $req->fetch()) {
			$req = $bdd->prepare('UPDATE `forum_cache_topics` SET `master`=?, `type`=?, `title`=?, `author_html`=?, `nb_msgs`=?, `date`=?, `last`=?, `last_html`=?, `closed`=?, `resolved`=?, `tags`=? WHERE `id`=? LIMIT 1');
			$req->execute(array($data['master'], $data['type'], $data['title'], $authorhtml, $n, $data['date'], $lastdate, $lastauthorhtml, $data['closed'], $data['resolved'], $data['tags'], $data2['id']));
		}
		else {
			$req = $bdd->prepare('INSERT INTO `forum_cache_topics` (`topic_id`, `master`, `type`, `title`, `author_html`, `nb_msgs`, `date`, `last`, `last_html`, `closed`, `resolved`, `tags`) VALUES (?,?,?,?,?,?,?,?,?,?,?,?)');
			$req->execute(array($id, $data['master'], $data['type'], $data['title'], $authorhtml, $n, $data['date'], $lastdate, $lastauthorhtml, $data['closed'], $data['resolved'], $data['tags']));
		}
		if($new) {
			if($n == 0) {
				$lastdate = $data['date'];
				$lastauthorhtml = $authorhtml;
			}
			$lastauthorhtml = '<a href="topic.php?t='.$data['id'].'#m'.$lastpost.'">'.htmlentities($data['title']).'</a><br />'.$lastauthorhtml;
			$master = $data['master'];
			while($master != 0) {
				$req = $bdd->prepare('SELECT `id`, `master` FROM `forum_cat` WHERE `id`=? LIMIT 1');
				$req->execute(array($master));
				if($data2 = $req->fetch())
					$master = $data2['master'];
				else
					break;
				$req = $bdd->prepare('UPDATE `forum_cat` SET `last`=?, `last_html`=? WHERE `id`=? LIMIT 1');
				$req->execute(array($lastdate, $lastauthorhtml, $data2['id']));
			}
		}
		return true;
	}
	return false;
}

function forum_cache_hit_topic($id, $bdd) {
	$req = $bdd->prepare('SELECT `hits` FROM `forum_topics` WHERE `id`=? LIMIT 1');
	$req->execute(array($id));
	if($data = $req->fetch()) {
		$req = $bdd->prepare('SELECT `id` FROM `forum_cache_topics` WHERE `topic_id`=? LIMIT 1');
		$req->execute(array($id));
		if($data2 = $req->fetch()) {
			$req = $bdd->prepare('UPDATE `forum_cache_topics` SET `hits`=? WHERE `id`=? LIMIT 1');
			$req->execute(array($data['hits'], $data2['id']));
		}
		else
			forum_cache_topic($id, $bdd);
		return true;
	}
	return false;
}
?>